unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ComCtrls, StdCtrls, ExtCtrls, Buttons, DSPack, IniFiles, CPDrv, DsUtil,
  DirectShow9, IdBaseComponent, IdComponent, IdCustomTCPServer, IdTCPServer, IdContext, JPEG,
  IdTCPConnection, IdTCPClient;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    GroupBox1: TGroupBox;
    StatusBar1: TStatusBar;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    GroupBox2: TGroupBox;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    GroupBox3: TGroupBox;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    GroupBox4: TGroupBox;
    Button6: TButton;
    Button7: TButton;
    FilterGraph1: TFilterGraph;
    ComPort: TCommPortDriver;
    Filter1: TFilter;
    SampleGrabber1: TSampleGrabber;
    Image1: TImage;
    Timer1: TTimer;
    VideoWindow1: TVideoWindow;
    IdTCPServer1: TIdTCPServer;
    IdTCPClient1: TIdTCPClient;
    Timer2: TTimer;
    IdTCPServer2: TIdTCPServer;
    IdTCPClient2: TIdTCPClient;
    procedure Button7Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure IdTCPServer1Execute(AContext: TIdContext);
    procedure Timer2Timer(Sender: TObject);
    procedure IdTCPServer2Execute(AContext: TIdContext);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  run:byte;
  letfm,rightm:byte;
  l,r:string;
  CapEnum: TSysDevEnum;
  VideoMediaTypes: TEnumMediaType;

implementation

uses Unit2, Unit3, Unit4;

{$R *.dfm}
Procedure SendCMD(s:string);
Begin
    Form1.IdTCPClient2.Host:=Form4.Edit2.Text;
 //   IP 
    Form1.IdTCPClient2.Port:=StrToInt(Form4.Edit3.Text)+1;
    try
      Form1.IdTCPClient2.Connect;// 
      Form1.IdTCPClient2.IOHandler.WriteLn(s);//   
    finally
      Form1.IdTCPClient2.Disconnect;// 
    end;
End;
Function GetText(bb:byte):string;
Begin
 case bb of
    0:GetText:=': ';
    1:GetText:=': ';
    2:GetText:=': ';
    3:GetText:=': ';
 end;
End;
Procedure ChangeButtons(bb:byte);
var ini:TIniFile;

Begin
  case bb of
    0:Begin
        Form1.BitBtn1.Enabled:=True;
        Form1.BitBtn2.Enabled:=True;
        Form1.BitBtn3.Enabled:=False;
        Form1.BitBtn4.Enabled:=True;
        Form1.comport.SendString('$KE,REL,'+l+',0'+chr($0D)+chr($0A));
        Form1.comport.SendString('$KE,REL,'+r+',0'+chr($0D)+chr($0A));
      End;
    1:Begin
        Form1.BitBtn1.Enabled:=True;
        Form1.BitBtn2.Enabled:=True;
        Form1.BitBtn3.Enabled:=True;
        Form1.BitBtn4.Enabled:=False;
        Form1.comport.SendString('$KE,REL,'+l+',1'+chr($0D)+chr($0A));
        Form1.comport.SendString('$KE,REL,'+r+',0'+chr($0D)+chr($0A));
      End;
    2:Begin
        Form1.BitBtn1.Enabled:=True;
        Form1.BitBtn2.Enabled:=False;
        Form1.BitBtn3.Enabled:=True;
        Form1.BitBtn4.Enabled:=True;
        Form1.comport.SendString('$KE,REL,'+l+',0'+chr($0D)+chr($0A));
        Form1.comport.SendString('$KE,REL,'+r+',1'+chr($0D)+chr($0A));
      End;
    3:Begin
        Form1.BitBtn1.Enabled:=False;
        Form1.BitBtn2.Enabled:=True;
        Form1.BitBtn3.Enabled:=True;
        Form1.BitBtn4.Enabled:=True;
        Form1.comport.SendString('$KE,REL,'+l+',1'+chr($0D)+chr($0A));
        Form1.comport.SendString('$KE,REL,'+r+',1'+chr($0D)+chr($0A));
      End;
  end;
End;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  run:=3;
  ChangeButtons(run);
  StatusBar1.Panels[1].Text:=GetText(run);
  if Form4.RadioButton1.Checked then SendCMD('Forward');
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
  run:=2;
  ChangeButtons(run);
  StatusBar1.Panels[1].Text:=GetText(run);
  if Form4.RadioButton1.Checked then SendCMD('Left');
end;

procedure TForm1.BitBtn3Click(Sender: TObject);
begin
  run:=0;
  ChangeButtons(run);
  StatusBar1.Panels[1].Text:=GetText(run);
  if Form4.RadioButton1.Checked then SendCMD('Stop');
end;

procedure TForm1.BitBtn4Click(Sender: TObject);
begin
  run:=1;
  ChangeButtons(run);
  StatusBar1.Panels[1].Text:=GetText(run);
  if Form4.RadioButton1.Checked then SendCMD('Right');
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
 Form2.ShowModal;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Form3.ShowModal;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  Form4.ShowModal;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 ChangeButtons(0);
 Comport.Disconnect;
 CapEnum.Free;
 VideoMediaTypes.Free;

end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 run:=0;
end;

procedure TForm1.FormShow(Sender: TObject);
var ini:TIniFile;
    s:string;
    i:integer;
begin
  ini:=TIniFile.Create('./robot.ini');
  s:=ini.ReadString('COM port','number','  ');
  leftm:=ini.ReadInteger('COM port','left',1);
  rightm:=ini.ReadInteger('COM port','right',2);
  l:=IntToStr(leftm);
  r:=IntToStr(rightm);

  if s<>'  ' then
    Begin
      Comport.PortName:='\\.\'+s;
      If ComPort.Connect Then StatusBar1.Panels[0].Text:='COM-port: '+s else
                              StatusBar1.Panels[0].Text:='COM-port:  ';
    End;
  StatusBar1.Panels[1].Text:=GetText(run);
  ChangeButtons(run);
  StatusBar1.Panels[0].Text:='COM-port: '+s;

  CapEnum := TSysDevEnum.Create(CLSID_VideoInputDeviceCategory);
  Form3.ComboBox1.Items.Add('  ');
  for i := 0 to CapEnum.CountFilters - 1 do
      Form3.ComboBox1.Items.Add(CapEnum.Filters[i].FriendlyName);
  s:=ini.ReadString('WEB-camera','Front','  ');
  i:=Form3.ComboBox1.Items.IndexOf(s);
  s:=ini.ReadString('Network','Computer_role','Client');
  if s='Server' Then
    Begin
      Form4.RadioButton2.Checked:=True;
      Form4.GroupBox2.Enabled:=True;
      Form4.GroupBox3.Enabled:=False;
      StatusBar1.Panels[2].Text:='  : ';
    End
  Else
    Begin
      Form4.RadioButton1.Checked:=True;
      Form4.GroupBox3.Enabled:=True;
      Form4.GroupBox2.Enabled:=False;
      StatusBar1.Panels[2].Text:='  : ';
    End;
  
  if i<>-1 then Form3.ComboBox1.ItemIndex:=i else Form3.ComboBox1.ItemIndex:=0;

  if (i>0) and (Form4.RadioButton2.Checked) then
    begin
       FilterGraph1.ClearGraph;
       FilterGraph1.Active:=false;
       Filter1.BaseFilter.Moniker:=CapEnum.GetMoniker(i-1);
       FilterGraph1.Active:=true;
       with FilterGraph1 as ICaptureGraphBuilder2 do
          RenderStream(@PIN_CATEGORY_PREVIEW, nil, Filter1 as IBaseFilter, SampleGrabber1 as IBaseFilter, VideoWindow1 as IbaseFilter);
       FilterGraph1.Play;
       Timer1.Enabled:=True;
    end;
  Unit3.def:=Form3.ComboBox1.ItemIndex;
  s:=ini.ReadString('Network','Server_IP','192.168.0.1');
  Form4.Edit2.Text:=s;
  s:=ini.ReadString('Network','Server_Port','8080');
  Form4.Edit1.Text:=s;
  s:=ini.ReadString('Network','Client_Port','8080');
  Form4.Edit3.Text:=s;
  i:=ini.ReadInteger('Network','JPG_Quality',50);
  Form4.TrackBar2.Position:=i;
  i:=ini.ReadInteger('Network','FPS',5);
  Form4.TrackBar1.Position:=i;
  Timer2.Interval:=1000 div i;
  ini.Free;
  If Form4.RadioButton2.Checked Then
    Begin
      IdTCPServer1.DefaultPort:=StrToInt(Form4.Edit1.Text);
      IdTCPServer1.Bindings.DefaultPort:=StrToInt(Form4.Edit1.Text);
      IdTCPServer1.Active:=True;
      IdTCPServer2.DefaultPort:=StrToInt(Form4.Edit1.Text)+1;
      IdTCPServer2.Bindings.DefaultPort:=StrToInt(Form4.Edit1.Text)+1;
      IdTCPServer2.Active:=True;
    End;
  if Form4.RadioButton1.Checked then Timer2.Enabled:=True;
end;

procedure TForm1.IdTCPServer1Execute(AContext: TIdContext);
var BM:TJPEGImage;
    cmd:string;
    Stream:TMemoryStream;
begin
 cmd:=AContext.Connection.IOHandler.ReadLn;// 
 if cmd='Give_Image' then//   
    begin
      BM:=TJPEGImage.Create.Create;
      Stream:=TMemoryStream.Create;
      BM.Assign(image1.Picture.Bitmap);
      BM.CompressionQuality:=Form4.TrackBar2.Position;
      BM.Compress;
      BM.SaveToStream(Stream);
      Stream.Position:=0;
      // 
      try
        AContext.Connection.IOHandler.Write(Stream,Stream.Size,true);
      finally
        AContext.Connection.Disconnect;
        BM.Free;
        Stream.Free;
      end;
    end;
end;

procedure TForm1.IdTCPServer2Execute(AContext: TIdContext);
var cmd:string;
begin
  cmd:=AContext.Connection.IOHandler.ReadLn;// 
  if cmd='Forward' then BitBtn1Click(Application);
  if cmd='Stop' then BitBtn3Click(Application);
  if cmd='Left' then BitBtn2Click(Application);
  if cmd='Right' then BitBtn4Click(Application);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  if FilterGraph1.Active Then
      SampleGrabber1.GetBitmap(Image1.Picture.Bitmap);
end;

procedure TForm1.Timer2Timer(Sender: TObject);
 var Stream:TMemoryStream;
     BM:TJPEGImage;
begin
    Stream:=TMemoryStream.Create;
    BM:=TJPEGImage.Create;
    IdTCPClient1.Host:=Form4.Edit2.Text;
 //   IP 
    IdTCPClient1.Port:=StrToInt(Form4.Edit3.Text);
    try
      IdTCPClient1.Connect;// 
      IdTCPClient1.IOHandler.WriteLn('Give_Image');//   
      //  
      IdTCPClient1.IOHandler.ReadStream(Stream);// 
      Stream.Position:=0;
      BM.CompressionQuality:=100;
      BM.LoadFromStream(Stream);
      image1.Picture.Bitmap.Assign(BM);
    finally
      IdTCPClient1.Disconnect;// 
      BM.Free;
      Stream.Free;
    end;
end;

end.
