unit Unit4;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, ComCtrls, StdCtrls, IniFiles;

type
  TForm4 = class(TForm)
    Panel1: TPanel;
    GroupBox1: TGroupBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    GroupBox2: TGroupBox;
    TrackBar1: TTrackBar;
    Label1: TLabel;
    Label2: TLabel;
    TrackBar2: TTrackBar;
    GroupBox3: TGroupBox;
    Label3: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    Edit3: TEdit;
    Panel2: TPanel;
    Button1: TButton;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form4: TForm4;

implementation

{$R *.dfm}

procedure TForm4.Button1Click(Sender: TObject);
var ini:TIniFile;
begin
  ini:=TIniFile.Create('./robot.ini');
  if Radiobutton1.Checked then ini.WriteString('Network','Computer_role','Client')
      Else ini.WriteString('Network','Computer_role','Server');
  ini.WriteString('Network','Server_IP',Edit2.Text);
  ini.WriteString('Network','Server_Port',Edit1.Text);
  ini.WriteString('Network','Client_Port',Edit3.Text);
  ini.WriteInteger('Network','JPG_Quality',TrackBar2.Position);
  ini.WriteInteger('Network','FPS',TrackBar1.Position);
  ini.Free;
  ShowMessage('   '+#13+'    .');
  Form4.Close;
end;

procedure TForm4.Button2Click(Sender: TObject);
begin
  Form4.Close;
end;

procedure TForm4.FormClose(Sender: TObject; var Action: TCloseAction);
var ini:TIniFile;
    i:integer;
    s:string;
begin
  ini:=TIniFile.Create('./robot.ini');
  s:=ini.ReadString('Network','Computer_role','Client');
  if s='Server' Then
    Begin
      RadioButton2.Checked:=True;
      GroupBox2.Enabled:=True;
      GroupBox3.Enabled:=False;
    End
  Else
    Begin
      RadioButton1.Checked:=True;
      GroupBox3.Enabled:=True;
      GroupBox2.Enabled:=False;
    End;
  s:=ini.ReadString('Network','Server_IP','192.168.0.1');
  Edit2.Text:=s;
  s:=ini.ReadString('Network','Server_Port','8080');
  Edit1.Text:=s;
  s:=ini.ReadString('Network','Client_Port','8080');
  Edit3.Text:=s;
  i:=ini.ReadInteger('Network','JPG_Quality',50);
  TrackBar2.Position:=i;
  i:=ini.ReadInteger('Network','FPS',5);
  TrackBar1.Position:=i;
  ini.Free;

end;

procedure TForm4.RadioButton1Click(Sender: TObject);
begin
  GroupBox3.Enabled:=True;
  GroupBox2.Enabled:=False;
end;

procedure TForm4.RadioButton2Click(Sender: TObject);
begin
  GroupBox2.Enabled:=True;
  GroupBox3.Enabled:=False;
end;

end.
