unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, IniFiles;

type
  TForm2 = class(TForm)
    Label1: TLabel;
    Panel1: TPanel;
    ComPort: TComboBox;
    Button1: TButton;
    Button2: TButton;
    GroupBox1: TGroupBox;
    Label2: TLabel;
    LeftMotor1: TRadioButton;
    LeftMotor2: TRadioButton;
    LeftMotor3: TRadioButton;
    LeftMotor4: TRadioButton;
    GroupBox2: TGroupBox;
    Label3: TLabel;
    RightMotor1: TRadioButton;
    RightMotor2: TRadioButton;
    RightMotor3: TRadioButton;
    RightMotor4: TRadioButton;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public

    { Public declarations }
  end;

var
  Form2: TForm2;
  ini:TIniFile;
  def,leftm,rightm:integer;

implementation

uses Unit1;

{$R *.dfm}

procedure TForm2.Button1Click(Sender: TObject);
begin
 ShowMessage('   '+#13+'    .');
 Form2.Close;
 Form1.StatusBar1.Panels[0].Text:='COM-port: '+ComPort.Text;
 ini:=TIniFile.Create('./robot.ini');
 ini.WriteString('COM port','number',ComPort.Text);
 if LeftMotor1.Checked then leftm:=1;
 if LeftMotor2.Checked then leftm:=2;
 if LeftMotor3.Checked then leftm:=3;
 if LeftMotor4.Checked then leftm:=4;
 If RightMotor1.Checked then Rightm:=1;
 If RightMotor2.Checked then Rightm:=2;
 If RightMotor3.Checked then Rightm:=3;
 If RightMotor4.Checked then Rightm:=4;
 ini.WriteInteger('COM port','left',leftm);
 ini.WriteInteger('COM port','right',rightm);
 ini.Free;
end;

procedure TForm2.Button2Click(Sender: TObject);
begin
 ComPort.ItemIndex:=def;
 case leftm of
    1: LeftMotor1.Checked:=True;
    2: LeftMotor2.Checked:=True;
    3: LeftMotor3.Checked:=True;
    4: LeftMotor4.Checked:=True;
 end;
 Case Rightm of
    1: RightMotor1.Checked:=True;
    2: RightMotor2.Checked:=True;
    3: RightMotor3.Checked:=True;
    4: RightMotor4.Checked:=True;
 End;
 Form2.Close;
end;

procedure TForm2.FormCreate(Sender: TObject);
var i:integer;
    FHandl: THandle; { }
    DCB: TDCB; {    }
    PortName: string;
begin
  ComPort.Items.Clear;
  ComPort.Items.Add('  ');
  for i := 0 to 31 do { }
  begin {   }
    FHandl := CreateFile(PChar('COM' + IntToStr(i + 1)),
            GENERIC_READ or GENERIC_WRITE,
            0,
            nil,
            OPEN_EXISTING, FILE_FLAG_OVERLAPPED, 0);
    if FHandl <> INVALID_HANDLE_VALUE then {      }
      ComPort.Items.Add('COM' + IntToStr(i + 1));
    CloseHandle(FHandl); { }
  end;
  ini:=TIniFile.Create('./robot.ini');
  PortName:=ini.ReadString('COM port','number','');
  leftm:=ini.ReadInteger('COM port','left',1);
  Rightm:=ini.ReadInteger('COM port','right',2);
  Ini.Free;
  if PortName='' then ComPort.ItemIndex:=0;
  i:=ComPort.Items.IndexOf(PortName);
  if i<>-1 then ComPort.ItemIndex:=i;
  case leftm of
    1: LeftMotor1.Checked:=True;
    2: LeftMotor2.Checked:=True;
    3: LeftMotor3.Checked:=True;
    4: LeftMotor4.Checked:=True;
  end;
  Case Rightm of
    1: RightMotor1.Checked:=True;
    2: RightMotor2.Checked:=True;
    3: RightMotor3.Checked:=True;
    4: RightMotor4.Checked:=True;
  End;
  def:=ComPort.ItemIndex;
end;

procedure TForm2.FormShow(Sender: TObject);
begin
    ComPort.SetFocus;
end;

end.
